<?php

// --------------
// --- BXTags ---
// --------------



function replaceSmileys($txt) {
	global $smileys, $use_autoformat;
	
	$isXHTML = (strtolower($use_autoformat)=='xhtml');
	$imgend = ($isXHTML) ? ' /> ' : '> ';
	$txt = $txt.' ';
	
	if ($smileys['smile'])  $txt = preg_replace('/ (\(?\:\-?\)) /m',' <img src="'.$smileys['smile'].'" alt="\\1"'.$imgend, $txt);
	if ($smileys['laught'])	$txt = preg_replace('/ (\(?\:\-?(\){2,}|D+)) /m',' <img src="'.$smileys['laught'].'" alt="\\1"'.$imgend, $txt);
	if ($smileys['blink']) 	$txt = preg_replace('/ (\(?\;\-?\)) /m',' <img src="'.$smileys['blink'].'" alt="\\1"'.$imgend, $txt);
	if ($smileys['grr'])   	$txt = preg_replace('/ ([\(\)]?\:\-?\[+) /m',' <img src="'.$smileys['grr'].'" alt="\\1"'.$imgend, $txt);
	if ($smileys['hmm'])   	$txt = preg_replace('/ (\(?\:\-?\/) /m',' <img src="'.$smileys['hmm'].'" alt="\\1"'.$imgend, $txt);
	if ($smileys['oops'])  	$txt = preg_replace('/ (\(?\:\-?[o0]) /mi',' <img src="'.$smileys['oops'].'" alt="\\1"'.$imgend, $txt);
	if ($smileys['sad'])   	$txt = preg_replace('/ ([\(\)]?\:\-?\(+) /m',' <img src="'.$smileys['sad'].'" alt="\\1"'.$imgend, $txt);

	return chop($txt);
	}




function BXTagsParser(&$lines) {
	global $use_autoformat;

	$isXHTML = (strtolower($use_autoformat)=='xhtml');

	$esc = '\\';
	$brTag = ($isXHTML) ? 'br /':'br';
	$hrTag = ($isXHTML) ? 'hr /':'hr';

	$buff = '';
	$parse = true;
	
	$isPRE = false;
	$prevTag = '';
	$par = '';
	$prevl = '';
	$lCnt = count($lines);
	
	for ($i=0;$i<$lCnt;$i++) {

		$l = chop(str_replace("\t",' ',$lines[$i]));

		// ESC starts/stops parsing
		if (!$parse) {
			if ($l==$esc) $parse = true;
			else $buff .= $l."\n";
			continue;
			}
		elseif ($l==$esc) {
			$parse = false;
			continue;
			}

		// ignore empty lines (but in PRE)
		if (!$isPRE && !trim($l)) continue;

		// + makes BR and joins with previous paragraph
		$l = ereg_replace('^\+(.*)','\\1',$l);
		if ($i<($lCnt-1) && substr($lines[$i+1],0,1)=='+') {
			$prevl .= $l.'<'.$brTag.'>'."\n";
			continue;
			}
		else {
			$l = $prevl.$l;
			$prevl = '';
			}

		$stag = '';
		$etag = '';
		$comment = false;

		// % starts parsing if stopped
		if (ereg('^([^ ]+)(.*)$',$l,$r)) {
			$fst = $r[1];
			$rest = trim($r[2]);
			}
		else {
			$fst='';
			$rest='';
			}
		
	// special paragraphs
		// {{ starts PRE
		if ($l=='{--') {
			$par = '';
			$stag = 'pre';
			}
		// }} stops PRE
		elseif ($l=='--}') {
			$par = '';
			$etag = 'pre';
			}
		// --- is HR
		elseif (ereg('^---+$',$l) && !$rest) {
			$par = '';
			$stag = $hrTag;
			}
	// paragraph prefixes
		// ESC stops parsing line
		elseif ($fst==$esc) {
			$par = $rest;
			}
		// || comment line
		elseif ($fst=='||') {
			$par = $rest;
			$comment = true;
			}
		// ||| invisible line
		elseif ($fst=='|||') {
			$par = '';
			}
		// : - :::: makes H4-H1
		elseif (ereg('^(:+)',$fst,$r)) {
			if ($r[1]=='::::') $stag = 'h1';
			elseif ($r[1]==':::') $stag = 'h2';
			elseif ($r[1]=='::') $stag = 'h3';
			else $stag = 'h4';
			$etag = $stag;
			$par = parseLine($rest);
			}
		elseif ($fst=='"') {
			$stag = 'blockquote><div';
			$etag = 'div></blockquote';
			$par = parseLine($rest);
			}
		elseif ($fst=='#') {
			$stag = 'ol';
			$par = parseLine($rest);
			}
		elseif ($fst=='.' || $fst=='-' || $fst=='*') {
			$stag = 'ul';
			$par = parseLine($rest);
			}
		// =class makes paragraph with class
		elseif (ereg('=(.*)',$fst,$r)) {
			$stag = 'div class="'.$r[1].'"'; // changed to div
			$etag = 'div';
			$par = parseLine($rest);
			}
		else {
			$par = parseLine($l);
			}
		
		$prefix = '';
		$par = chop($par);

		if ($stag=='pre') $isPRE = true;
		if (!$stag && !$isPRE && $par) { $stag='p'; $etag='p'; }

		if ($stag && $stag!='ol' && $prevTag=='ol') $prefix .= '</ol>'."\n";
		if ($stag && $stag!='ul' && $prevTag=='ul') $prefix .= '</ul>'."\n";
		if ($stag=='ol' && $prevTag!='ol') $prefix .= '<ol>'."\n";
		if ($stag=='ul' && $prevTag!='ul') $prefix .= '<ul>'."\n";

		if ($stag || $etag) $prevTag = ($stag) ? $stag : $etag;

		$t1 = ''; $t2 = '';
		if ($stag=='ol' || $stag=='ul') { $t1='   <li>'; $t2='</li>'; }
		else {
			if ($stag) $t1 = '<'.$stag.'>';
			if ($etag) $t2 = '</'.$etag.'>';
			if ($stag=='blockquote') { $t1=$t1.'<p>'; $t2='</p>'.$t2; }
			}
		if ($comment) $par = '<!--'.$par.'-->';
		else $par = $prefix.$t1.$par.$t2;
		if ($par || $isPRE) $buff .=  $par . "\n";

		if ($etag=='pre') $isPRE = false;
		}

	if ($prevTag=='ol') $buff .= '</ol>'."\n";
	if ($prevTag=='ul') $buff .= '</ul>'."\n";

	return $buff;
	}


function parseLine($txt) {
	global $replace_smileys, $use_autoformat;
	
	$isXHTML = (strtolower($use_autoformat)=='xhtml');
	$imgend = ($isXHTML) ? ' />' : '>';
	
	$esc = '\\';
	
	$buff = '';

	$HTML = false;
	
	$isStrong = false;
	$isEm = false;
	$isTagStart = false;
	$isTagEnd = false;

	$tagCnt = -1;

	$txt = preg_replace("/(\\$esc(.))/e",'"#esc#".ord("\\2")."#esc#"',$txt);

//	$txt = preg_replace('/\[\?([^]]*)\|([^]]*)\]/','<span class="help" title="\\2">\\1</span>',$txt);
	$txt = ereg_replace('\[\?([^]]*)\|([^]]*)\]','<abbr title="\\2">\\1</abbr>',$txt);
	$txt = ereg_replace('\[\?([^]]*)\]','<abbr>\\1</abbr>',$txt);

  $txt = preg_replace('/\[@([^]]*)\|([^]]*)\|([^]]*)\]/','<a href="\\1"><img src="\\3" alt="\\2"'.$imgend.'</a>',$txt);
	$txt = preg_replace('/\[@([^]]*)\|([^]]*)\]/','<img src="\1" alt="\2"'.$imgend,$txt);


	$txt = preg_replace('/\[([^]]*)\|([^]]*)\|([^]]*)\]/','<a href="\3" title="\2">\1</a>',$txt);
	$txt = preg_replace('/\[([^]]*)\|([^]]*)\]/','<a href="\2">\1</a>',$txt);
	$txt = preg_replace('/\[(.*?)\]/','<a href="\1">\1</a>',$txt);


  $txt = preg_replace('/\{\{"(.*?)\}\}/','<q>\1</q>',$txt);
	$txt = preg_replace('/\{\{\'(.*?)\}\}/','<cite>\1</cite>',$txt);
	$txt = preg_replace('/\{\{\-(.*?)\}\}/','<span>\1</span>',$txt);
	$txt = preg_replace('/\{\{(.*?)\}\}/','<code>\1</code>',$txt);

// * -> <strong>
  $txt = preg_replace('/\*(.*?)\*/','<strong>\1</strong>',$txt);	
	
// ~ -> <em>	
	$txt = preg_replace('/href(.*?)~+(.*?)>/','href\1###vl###\2>',$txt);
	$txt = preg_replace('/~(.*?)~/','<em>\1</em>',$txt);
  $txt = str_replace('###vl###','~',$txt);


// _ -> &nbsp;

  $txt = preg_replace('/ (.?\w{1,3}.?)_(.?\w{1,})/',' \1&#xA0;\2',$txt);


	if ($replace_smileys) $txt = replaceSmileys($txt);


  $txt = str_replace('->','&#x2192;',$txt);
  $txt = str_replace('<-','&#x2190;',$txt);
  $txt = str_replace('+-','&#xB1;',$txt);
  $txt = str_replace('(c)','&#xA9;',$txt);
  $txt = str_replace('(r)','&#xAE;',$txt);
  $txt = str_replace('1/4','&#xBC;',$txt);
  $txt = str_replace('1/2','&#xBD;',$txt);
  $txt = str_replace('3/4','&#xBE;',$txt);
  $txt = str_replace('^a','&#xAA;',$txt);
  $txt = str_replace('^o','&#xB0;',$txt);
  $txt = str_replace('^1','&#xB9;',$txt);
  $txt = str_replace('^2','&#xB2;',$txt);
  $txt = str_replace('^3','&#xB3;',$txt);
  $txt = str_replace('%%','&#x2030;',$txt);


	$txt = str_replace('#esc#60#esc#','&#x3C;',$txt); // less than <
	$txt = str_replace('#esc#62#esc#','&#x3E;',$txt); // greater than >
	$txt = str_replace(' - ',' &#x2013; ',$txt); // &ndash;
	$txt = preg_replace('/#esc#([0-9]+)#esc#/e','chr(\\1)',$txt);
  $txt = str_replace('...','&#x2026;',$txt);
	return $txt;
	
	}


?>
